Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml	(revision 12832)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml	(revision 12833)
@@ -46,5 +46,8 @@
                           DisplayMemberPath="Name"
                           SelectedValue="{Binding SelectedPolicy}"
-                          Width="200" Margin="5,0,0,0"></ComboBox>
+                          Width="200" Margin="5,0,0,0"
+                          SelectionChanged="ComboBoxPolicies_OnSelectionChanged"></ComboBox>
+                <TextBlock Name="TextBlockEpsylon" Text="Epsylon:" Visibility="Hidden" Margin="5,0,0,0" VerticalAlignment="Center"></TextBlock>
+                <TextBox Name="TextBoxEpsylon" Text="{Binding Epsylon}" Visibility="Hidden" Margin="5,0,0,0" VerticalAlignment="Center" Width="50"></TextBox>
                 <Button Name="ButtonRun" Margin="5,0,0,0" Click="ButtonRun_OnClick" Height="22" VerticalAlignment="Top">Run</Button>
                 <Button Name="ButtonPause" Margin="5,0,0,0" Click="ButtonPause_OnClick" IsEnabled="False">Pause</Button>
@@ -74,5 +77,5 @@
                 <TextBox Name="TextBoxMaxIterations" Margin="2" Grid.Column="1" Grid.Row="1" Width="100" VerticalAlignment="Center" TextAlignment="Right" Text="{Binding MaxIterations}"></TextBox>
                 <TextBlock Margin="2" Grid.Column="2" Grid.Row="1" VerticalAlignment="Center">MaxThreads:</TextBlock>
-                <TextBox Name="MaxThreads" Margin="2" Grid.Column="3" Grid.Row="1" Width="100" VerticalAlignment="Center" TextAlignment="Right" Text="{Binding MaxThreads}"></TextBox>
+                <TextBox Name="TextBoxMaxThreads" Margin="2" Grid.Column="3" Grid.Row="1" Width="100" VerticalAlignment="Center" TextAlignment="Right" Text="{Binding MaxThreads}"></TextBox>
                 <TextBlock Margin="2" Grid.Column="2" Grid.Row="0" VerticalAlignment="Center">MaxLen:</TextBlock>
                 <TextBox Name="TextBoxMaxLen" Margin="2" Grid.Column="3" Grid.Row="0" Width="100" VerticalAlignment="Center" TextAlignment="Right" Text="{Binding MaxLen}"></TextBox>
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml.cs	(revision 12832)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/MainWindow.xaml.cs	(revision 12833)
@@ -156,4 +156,5 @@
             TextBoxMaxLen.IsEnabled = true;
             TextBoxRuns.IsEnabled = true;
+            TextBoxMaxThreads.IsEnabled = true;
         }
 
@@ -181,10 +182,12 @@
                 policyInstance = new BoltzmannExplorationPolicy(2);
             }
+            else if (policy == typeof (EpsGreedyPolicy))
+            {
+                policyInstance = new EpsGreedyPolicy(vm.Epsylon);
+            }
             else
             {
                 policyInstance = (IBanditPolicy)Activator.CreateInstance(policy);
             }
-
-
 
             for (int i = 0; i < vm.NrRuns; i++)
@@ -428,4 +431,18 @@
             Clipboard.SetData(DataFormats.Text, tableExport.ToString());
         }
+
+        private void ComboBoxPolicies_OnSelectionChanged(object sender, SelectionChangedEventArgs e)
+        {
+            if (vm.SelectedPolicy == typeof (EpsGreedyPolicy))
+            {
+                TextBoxEpsylon.Visibility = Visibility.Visible;
+                TextBlockEpsylon.Visibility = Visibility.Visible;
+            }
+            else
+            {
+                TextBoxEpsylon.Visibility = Visibility.Hidden;
+                TextBlockEpsylon.Visibility = Visibility.Hidden;
+            }
+        }
     }
 }
Index: /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/ViewModel/EvaluationViewModel.cs
===================================================================
--- /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/ViewModel/EvaluationViewModel.cs	(revision 12832)
+++ /branches/HeuristicLab.Problems.GrammaticalOptimization/Evaluation/ViewModel/EvaluationViewModel.cs	(revision 12833)
@@ -119,4 +119,16 @@
                 this.maxThreads = value;
                 this.OnPropertyChanged("MaxThreads");
+            }
+        }
+
+        private double epsylon;
+
+        public double Epsylon
+        {
+            get { return this.epsylon; }
+            set
+            {
+                this.epsylon = value;
+                this.OnPropertyChanged("Epsylon");
             }
         }