Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj	(revision 12852)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/HeuristicLab.Services.Hive.DataAccess-3.3.csproj	(revision 12853)
@@ -133,5 +133,7 @@
     <Compile Include="Enums\CpuArchitecture.cs" />
     <Compile Include="Interfaces\IPersistenceManager.cs" />
+    <Compile Include="Interfaces\ITransactionManager.cs" />
     <Compile Include="Manager\PersistenceManager.cs" />
+    <Compile Include="Manager\TransactionManager.cs" />
     <Compile Include="Plugin.cs" />
     <Compile Include="HiveDataContext.cs">
@@ -143,5 +145,4 @@
       <DependentUpon>HiveDataContext.dbml</DependentUpon>
     </Compile>
-    <Compile Include="Interfaces\ITransactionManager.cs" />
     <Compile Include="Enums\TaskState.cs" />
     <Compile Include="Logger.cs" />
@@ -155,5 +156,4 @@
     </Compile>
     <Compile Include="Enums\SlaveState.cs" />
-    <Compile Include="Manager\TransactionManager.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -182,5 +182,4 @@
   <ItemGroup>
     <Content Include="SQL Scripts\Initialize Hive Database.sql" />
-    <Content Include="SQL Scripts\Migrate to Filestream.sql" />
     <Content Include="SQL Scripts\Prepare Hive Database.sql" />
   </ItemGroup>
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/PersistenceManager.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/PersistenceManager.cs	(revision 12852)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Manager/PersistenceManager.cs	(revision 12853)
@@ -202,5 +202,4 @@
     #endregion
 
-    // str.Remove(str.IndexOf(','));
     public TableInformation GetTableInformation(string table) {
       string query = string.Format("sp_spaceused '{0}', @updateusage='true'", table);
@@ -224,7 +223,7 @@
 
     public void Dispose() {
-      //if (dataContext != null) {
-      //  dataContext.Dispose();
-      //}
+      if (dataContext != null) {
+        dataContext.Dispose();
+      }
     }
 
Index: anches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/SQL Scripts/Migrate to Filestream.sql
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive.DataAccess/3.3/SQL Scripts/Migrate to Filestream.sql	(revision 12852)
+++ 	(revision )
@@ -1,79 +1,0 @@
-/* Upgrade script from HeuristicLab Hive 3.3.8 to 3.3.9 */
-
-USE [HeuristicLab.Hive-3.3]
-
-EXEC sp_configure filestream_access_level, 2
-GO
-RECONFIGURE
-GO 
-
-/**********************************************************/
-
-/* Move old Task Data */
-
-CREATE TABLE [dbo].[TaskDataTemp](
-  [TaskId] UniqueIdentifier RowGuidCol NOT NULL,
-  [Data] VarBinary(MAX) Filestream NOT NULL,
-  [LastUpdate] DateTime NOT NULL,
-  CONSTRAINT [PK_dbo.TaskDataTemp] PRIMARY KEY ([TaskId])
-)
-
-INSERT INTO dbo.TaskDataTemp (TaskId, Data, LastUpdate)
-SELECT TaskId, Data, LastUpdate
-FROM dbo.TaskData
-
-DELETE FROM dbo.TaskData
-
-/* Alter TaskId and Data Column */
-
-ALTER TABLE dbo.TaskData
-ALTER COLUMN [TaskId] ADD RowGuidCol
-
-ALTER TABLE dbo.TaskData
-DROP COLUMN Data
-
-ALTER TABLE dbo.TaskData
-ADD [Data] VarBinary(MAX) Filestream NOT NULL
-
-/* Insert data */
-
-INSERT INTO dbo.TaskData (TaskId, Data, LastUpdate)
-SELECT TaskId, Data, LastUpdate
-FROM dbo.TaskDataTemp
-
-DROP TABLE dbo.TaskDataTemp
-
-
-/**********************************************************/
-
-/* Move old Plugin Data */
-
-CREATE TABLE [dbo].[PluginDataTemp](
-  [PluginDataId] UniqueIdentifier RowGuidCol NOT NULL,
-  [PluginId] UniqueIdentifier NOT NULL,
-  [Data] VarBinary(MAX) FileStream NOT NULL,
-  [FileName] VarChar(MAX) NOT NULL,
-  CONSTRAINT [PK_dbo.PluginDataTemp] PRIMARY KEY ([PluginDataId])
-)
-
-INSERT INTO dbo.PluginDataTemp (PluginDataId, PluginId, Data, [FileName])
-SELECT PluginDataId, PluginId, Data, [FileName]
-FROM dbo.PluginData
-
-DELETE FROM dbo.PluginData
-
-/* Alter Data Column */
-
-ALTER TABLE dbo.PluginData
-DROP COLUMN Data
-
-ALTER TABLE dbo.PluginData
-ADD [Data] VarBinary(MAX) Filestream NOT NULL
-
-/* Insert data */
-
-INSERT INTO dbo.PluginData (PluginDataId, PluginId, Data, [FileName])
-SELECT PluginDataId, PluginId, Data, [FileName]
-FROM dbo.PluginDataTemp
-
-DROP TABLE dbo.PluginDataTemp
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Converter.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Converter.cs	(revision 12852)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Converter.cs	(revision 12853)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Linq;
 using DA = HeuristicLab.Services.Hive.DataAccess;
Index: /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/NewEventManager.cs
===================================================================
--- /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/NewEventManager.cs	(revision 12852)
+++ /branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/NewEventManager.cs	(revision 12853)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Linq;
 using HeuristicLab.Services.Hive.DataAccess;